/****************************************************************
 * m_mask.c
 * Last change 12-23-2013 by Osman Celimli
 ****************************************************************/
#define _CRTDBG_MAP_ALLOC
#include <stdlib.h>
#include <crtdbg.h>

#include <stdio.h>
#include <string.h>
#include <windows.h>

#include "useful.h"
#include "options.h"
/****************************************************************
 * Important Globals
 ****************************************************************/
unsigned char ucMask = 0xFF;
/****************************************************************
 * Text Tables
 ****************************************************************/
char ERR_BigMask[]= "ERROR- Masking value exceeds 8-Bit constraints.\n";
/****************************************************************
 * int m_setBitMask(char *pszNewMask)
 * Set our bit mask using the supplied string.
 ****************************************************************/
#define INT_RATIO (sizeof(unsigned int) / sizeof(unsigned char))
int m_setBitMask(char *pszNewBits)
{
	unsigned char aucBigMask[INT_RATIO];
	unsigned int uiBigMask,uiX;

	if(strtoint(pszNewBits, &uiBigMask)) return -1;
	memcpy(aucBigMask, &uiBigMask, (INT_RATIO * sizeof(char)));

	/**
	 * Assuming little-endian...
	 */
	for(uiX = (INT_RATIO - 1); uiX > 0; uiX--)
	{
		if((aucBigMask[uiX] != 0x00) && (aucBigMask[uiX] != 0xFF))
		{
			fprintf(stderr, "%s", ERR_BigMask);
			return -1;
		}
	}
	ucMask = aucBigMask[0];
	return 0;
}
/****************************************************************
 * unsigned char m_maskBits(unsigned char ucByte)
 * Mask the bits of the given byte using our current mask setting.
 ****************************************************************/
unsigned char m_maskBits(unsigned char ucByte)
{
	return ucByte & ucMask;
}
